Index: /trunk/SophyaPI/PI/pihisto2d.cc
===================================================================
--- /trunk/SophyaPI/PI/pihisto2d.cc	(revision 82)
+++ /trunk/SophyaPI/PI/pihisto2d.cc	(revision 83)
@@ -6,9 +6,18 @@
 
 //++
+// Class	PIHisto2D,PIH2DWdg,H2WinArg
+// Lib	PI
+// include	pihisto2d.h
+//
+//	Classes de dessin des histogrammes a 2 dimensions.
+//--
+
+
+//++
 PIHisto2D::PIHisto2D(Histo2D* histo, bool ad)
+//
+//	Createur d'une classe de dessin pour l'histogramme 2D histo.
+//--
 : PIScDrawer(), mHisto(histo)
-//
-//	Createur d'une classe de dessin pour l'histogramme 2D histo.
-//--
 {
 mAdDO = ad;     // Flag pour suppression automatique de mHisto  
@@ -78,6 +87,7 @@
 //|            ou N est le nombre de pixels ecran contenu
 //|            dans un bin de l'histogramme.
-//| Type = 2 : code a la "hbook2"
-//| Type = 3 : carres de tailles fixes en couleur
+//| Type = 2 : code a la "hbook2" " .+123...9AB...YZ*"
+//|            (cf detail PIHisto2D::HPrint2)
+//| Type = 3 : carres de tailles fixes (couleur).
 //--
 {
@@ -106,5 +116,5 @@
 //
 //	Pour definir la fraction de la dynamique a dessiner:
-//| Pour certains type de display (f=[0,1] cf UseDyn),
+//| Certains type de display (f=[0,1] cf PIHisto2D::UseDyn),
 //|    - on ne dessine rien si f <= frmin
 //|    - on limite l'excursion a f*frmax cad [...,frmax]
@@ -130,5 +140,10 @@
 }
 
+//++
 void PIHisto2D::UpdateSize()
+//
+//	Definition des tailles graphiques en fonction
+//	des caracteristiques de l'histogramme a dessiner.
+//--
 {
   if (!mDrawer) return;
@@ -337,4 +352,8 @@
 /////////////////////////////////////////////////////////////////
 
+//++
+// LaTeX	XX
+// \newpage
+//--
 
 static H2WinArg* h2dWinArg=NULL;
@@ -345,8 +364,8 @@
 //
 //	Createur d'un Widget de dessin d'histogramme 2D.
-//	Le menu pour choisir l'option d'affichage apparait suite au clic
-//	du bouton-3 de la souris.
-//--
-        : PIScDrawWdg(par,nom,sx,sy,px,py)
+//	Le menu pour choisir les options d'affichage apparait
+//	suite au clic du bouton-3 de la souris (cf H2WinArg::H2WinArg).
+//--
+: PIScDrawWdg(par,nom,sx,sy,px,py)
 {
 if (!h2dWinArg) h2dWinArg = new H2WinArg(this);
@@ -421,5 +440,5 @@
 //	Il est connecte a un histogramme donnee par l'action du
 //	du bouton-3 de la souris dans la fenetre contenant
-//	le dessin de l'histogramme.
+//	le dessin de l'histogramme (cf H2WinArg::H2WinArg).
 //--
 {
@@ -437,8 +456,45 @@
 
 //++
+// LaTeX	XX
+// \newpage
+//--
+
+//++
 H2WinArg::H2WinArg(PIH2DWdg *par)
 //
 //	Creation de la fenetre de gestion des parametres
-//	des dessins des histogrammes 2D.
+//	des dessins des histogrammes 2D. Cette fenetre de
+//	dialogue est partagee par tous les widget de dessin
+//	des histogrammes 2D. Pour la faire apparaitre pour la
+//	faire apparaitre la premiere fois, cliquez avec le bouton
+//	numero 3 de la souris (bouton de droite) dans la fenetre
+//	de dessin de l'histogramme. Si elle est deja presente,
+//	pour la connecter a une autre fenetre de dessin cliquez avec
+//	le meme bouton dans cette fenetre.
+//--
+//++
+//| - Menu 1: Choix du type de display
+//|     Carres variables, nuages de points, caracteres a la hbook2
+//|     et carres de tailles fixe (couleur ou niveauz de gris).
+//| - Menu 2: Choix du type d'echelle
+//|     Lineaire ou logarithmique
+//| - Menu 3: Choix de la couleur
+//|     noir et blanc, niveau de gris et couleurs diverses.
+//| - Champ texte Dyn: Pour donner la dynamique, si min>=max
+//|     alors prend le min et le max de l'histogramme
+//| - Champ texte Frac: fraction mini et maxi
+//|     (cf PIHisto2D::UseFrac)
+//| - Champ texte LogScal: niveau de scaling pour le choix d'une
+//|     echelle logarithmique (cf PIHisto2D::UseScale)
+//--
+//++
+//| - Curseur interactif PerPt: pourcentage de points a dessiner
+//|     dans chaque bin (cf PIHisto2D::UseDisplay)
+//| - Bouton Apply: dessiner avec les options affichees
+//| - Bouton close: fermeture de la fenetre de dialogue.
+//| - Bouton Get: re-prendre les valeurs de display stoquees
+//|     pour un histogramme donne.
+//| - Bouton Print: Imprimer les caracteristiques du display
+//|     et de l'histogramme.
 //--
 : PIWindow((PIMsgHandler *)par, "Options", PIWK_dialog,250,260,150,150)